/*

Copyright (C) 2006-2007, Iridesco, LLC.  All rights reserved.
Code and design: D. Wen

No portion of this code may be duplicated or reproduced in another widget
without written permission from Iridesco, LLC.: info@iridesco.com

1.0 - 11/1/06 - Initial release!
1.5 - 9/26/07 - A major clean up!
1.6 - 11/6/07 - Getting it to work in Leopard!
1.6.1 - 11/9/07 - Fix issue with http/https redirects

Hey you competitor, stop stealing our design and code!  We know who you are.

*/

/*
Thanks to D. Wen from Iridesco for permission to use existing Mac Widget code
as a starting point for my Vista Gadget

Vista Gadget Version Copyright (C) 2006-2007, The Karcher Group, Inc.  All rights reserved
Code and some design: D. Hall

Vista specific code may be reused, duplicated, or reproduced - just please let us know (we'd like to take
a look at what it is used in):   dan@thekarchergroup.com

1.0 - 12/13/2007  - Initial release
2.8 - 3/18/2008  - Fixed Task List not refreshing after time entry
2.9 - 10/15/2009  - Changed onreadystate to hand off response to result_handler instead of throwing networkError
*/


var version = 30;

var MAX_TOP_DISPLAY_LENGTH = 25;  // number of characters to display before trimming
var MAX_DRAWER_DISPLAY_LENGTH = 28;  // number of characters to display before trimming
var MAX_DAILY_ENTRIES=3;
var CURRENT_DAILY_ENTRY=0;
var CURRENT_DAILY_STOP=MAX_DAILY_ENTRIES;
var TASK_SCROLLING=false;

var timerRunning = false;
var currentDay;
var secondAttempt = false;
var currentEntryId;
var timerID;

var formExpanded = false;

var selectedTimer;
var clickDelay = new Array();  // used for buffering time to react to a double-click
var performEdit = false;
var refreshTimer;

var data = '';
var row_data = ''
var edit_row_data='' //row data used by timeentry.html
var startTime = new Date().getTime();

var networkStatusPosition = 1;
var networkStatusTimer;

var plusEnabled = true;




function initialize (event)
{
    var harvestURL = System.Gadget.Settings.read("envHarvestURL");
    var harvestEmail = System.Gadget.Settings.read("envHarvestEmail");
    var harvestPassword = System.Gadget.Settings.read("envHarvestPassword");

	//var imgGlow = imgGBackground.addImageObject("Images/main-body.png", 10, 10);
	//imgGlow.addShadow("black", 12, 80, 0, 0);

	if (harvestURL=="" || harvestEmail=="" || harvestPassword=="") {
	    projectDisplay.innerHTML="SETTINGS REQUIRED";
	    playPauseButton.style.display="none";
	    plusMinusButton.style.display="none";
	    try {
	        window.clearInterval(refreshTimer);
	    }
	    catch (e) {
	        refreshTimer=null;
	    }
	}
	else {
	    var harvestTaskScroll = System.Gadget.Settings.read("envHarvestTaskScroll");
	    if (harvestTaskScroll=="TRUE") {
	        TASK_SCROLLING=true;
	    }
	    else {
            CURRENT_DAILY_ENTRY=0;
            TASK_SCROLLING=false;
	    }
	    projectDisplay.innerHTML="Client - Project";
	    taskDisplay.innerHTML = "Task";
	    timeDisplay.innerHTML = "0.00";
	    playPauseButton.style.display="block";
	    plusMinusButton.style.display="block";
	    getVersionNumber();
	    refreshGadget();
	    refreshTimer=window.setInterval("refreshGadget()", 60 * 60000);
	    var protocol = "https://";
	    harvestLink.href=protocol+harvestURL+".harvestapp.com/timesheets"

	}


}

function refreshGadget() {
   perform_request("daily", handleDailyResult, "");
}


function goToHarvestPlans() {
	var harvestURL = System.Gadget.Settings.read("envHarvestURL");
	if (harvestURL.slice(0, 7) == "http://") harvestURL = harvestURL.slice(7, harvestURL.length);
	if (harvestURL.slice(0, 8) == "https://") harvestURL = harvestURL.slice(8, harvestURL.length);
    window.location.href="http://"+harvestURL+'.harvestapp.com/company/edit_plan';
}

/*----------------------------------------------------------------------------------
	Functions for button actions
----------------------------------------------------------------------------------*/
function handlePlusMinusClick(event, buttonID)
{
    if (plusEnabled) {
		if (formExpanded) {
			collapseForm();
		} else {
  			expandForm(true);
		}
  }
}

function handlePlayPauseClick(event, buttonID)
{
    if (selectedTimer){
        //document.getElementById('dateToday').innerHTML="daily/timer/" + selectedTimer.id;
        perform_request("daily/timer/" + selectedTimer.id, handleTimerToggleResult,"");
    }
    else
        if (playPauseButton.row_id) {
            perform_request("daily/timer/" + playPauseButton.row_id, handleTimerToggleResult,"");
        }
        else {
            expandForm();
       }
}

function handleSaveTimeClick(event, buttonID)
{

    // create the JSON object for save or update
    var project_id = projectInput.value;
    var task_id = taskInput.value;
    var notes = notesInput.value;
    var hours = convert_hhmm_to_decimal(hoursInput.value);

    var submitObj = {"notes": notes, "hours": hours, "project_id": project_id, "task_id": task_id, "spent_at": data.for_day};

    // if this is to update a row, get the row id from preferences
    if (performEdit) {
        action = "daily/update/" + currentEntryId;
        perform_request(action, handleDailyEditResult, submitObj);
        performEdit = false;
    }	else {
        perform_request("daily/add", handleDailyAddResult, submitObj);
    }

    // clear out notes and time fields
    notesInput.value = '';
    hoursInput.value = '';
    collapseForm();

}

function handleFlyoutHide() {
    collapseForm();
    CURRENT_DAILY_ENTRY=data.day_entries.length-MAX_DAILY_ENTRIES;
    if (CURRENT_DAILY_ENTRY<=0) {
        CURRENT_DAILY_ENTRY=0;
    }
    CURRENT_DAILY_STOP=data.day_entries.length;
    perform_request("daily", handleDailyResult, "");
}

function handleTaskNavigate(direction) {
    if (direction=='DOWN') {
        if (CURRENT_DAILY_ENTRY>=data.day_entries.length) {
            CURRENT_DAILY_ENTRY=data.day_entries.length;
        }
        CURRENT_DAILY_STOP=CURRENT_DAILY_STOP+MAX_DAILY_ENTRIES;
        if (CURRENT_DAILY_STOP>data.day_entries.length) {
            CURRENT_DAILY_STOP=data.day_entries.length
        }
    }
    else if (direction=='UP') {
        CURRENT_DAILY_ENTRY=CURRENT_DAILY_ENTRY-MAX_DAILY_ENTRIES-MAX_DAILY_ENTRIES;
        if (CURRENT_DAILY_ENTRY<0) {
            CURRENT_DAILY_ENTRY=0;
        }
        CURRENT_DAILY_STOP=CURRENT_DAILY_ENTRY+MAX_DAILY_ENTRIES;
        if (CURRENT_DAILY_STOP>=data.day_entries.length) {
            CURRENT_DAILY_STOP=data.day_entries.length
        }
    }

    if (CURRENT_DAILY_ENTRY<CURRENT_DAILY_STOP) {
        setupTaskTable();
    }

}

function handlemouseWheel() {
    if(event.wheelDelta < -20)
    {
        handleTaskNavigate('DOWN');
    }
    if(event.wheelDelta > 20)
    {
        handleTaskNavigate('UP');
    }
}

function handleCancelTimeClick(event, buttonID)
{
    System.Gadget.document.parentWindow.formCancelClick=true;
	// collapse the form
	collapseForm();

	// set edit flag to false
	performEdit = false;
}


function handleProjectInputChange(event, buttonID)
{
	loadTasksList(projectInput.value);
}




/*----------------------------------------------------------------------------------
	Toggle drawer functions
----------------------------------------------------------------------------------*/

// loads data
// create text rows for the data
// create background rows for the data
function setupTaskTable() {

	// fill in the backgorund
	var rowHeight=28;

	// update today's date
	newDay = data.for_day.substr(0, 11);

    dateToday.innerHTML = newDay;
    currentDay = newDay;

    var tableContainer = document.getElementById('tbody');
    removeAllChildren(tableContainer);
    var rowCount=0;
    bodyHeight=87;
    if (data.day_entries != null) {
        if (data.day_entries.length > 0) {
              if (!TASK_SCROLLING) {
                   taskNavigateContainer.style.display='none';
                  $A(data.day_entries).each(function(e){
			                var row = createRow(e);
			                bodyHeight=bodyHeight+rowHeight;
			                tableContainer.appendChild (row);
                    });
              } else {
                taskNavigateContainer.style.display='block';
                taskCurrentDisplay.innerHTML=parseInt(CURRENT_DAILY_ENTRY+1)+" to "+parseInt(CURRENT_DAILY_STOP);
                for (i=CURRENT_DAILY_ENTRY;i<CURRENT_DAILY_STOP;i++) {
                    var row = createRow(data.day_entries[i]);
                    tableContainer.appendChild (row);
                    rowCount++;
                }
                CURRENT_DAILY_ENTRY=CURRENT_DAILY_STOP;
             }
        } else {
            // create default rows
            var row = document.createElement('tr');
            row.style.backgroundImage = "url(Images/drawer-row.png)";
            var td = document.createElement ('td');
            td.className="pencil";
            //row.appendChild (td);
            //td = document.createElement ('td');
            td.appendChild (document.createTextNode("No entries today."));
            td.colSpan=2;
            row.appendChild (td);
            td = document.createElement('td');
            td.className="hours";
            td.setAttribute ("align", "right");
            td.innerHTML="&nbsp;"
            row.appendChild (td);
            tableContainer.appendChild(row);
            rowCount++;
            bodyHeight=bodyHeight+79;
            // reset display
            projectDisplay.innerHTML = "Client - Project";
            taskDisplay.innerHTML = "Task";
            timeDisplay.innerHTML = "0.00";
            taskNavigateContainer.style.display='none';
        }
    } else {
        var row = document.createElement('tr');
        row.style.backgroundImage = "url(Images/drawer-row.png)";
        var td = document.createElement ('td');
        td.className="pencil";
        td.appendChild (document.createTextNode("No entries today."));
        td.colspan=2;
        //row.appendChild (td);
        //td = document.createElement('td');
        td.className="hours";
        td.setAttribute ("align", "right");
        td.innerHTML="&nbsp;";
        row.appendChild (td);
        tableContainer.appendChild(row);
        rowCount++;
        bodyHeight=bodyHeight+79;

        // reset display
        projectDisplay.innerHTML = "Client - Project";
        taskDisplay.innerHTML = "Task";
        timeDisplay.innerHTML = "0.00";
        taskNavigateContainer.style.display='none';
    }


    if (!System.Gadget.docked) {
        bodyHeight=bodyHeight+rowHeight;
        if (bodyHeight<194) {
            bodyHeight=194;
        }
        if (TASK_SCROLLING) {
            while (rowCount%MAX_DAILY_ENTRIES!=0) {
                var row = document.createElement('tr');
                row.style.backgroundImage = "url(Images/drawer-row.png)";
                var td = document.createElement ('td');
                td.innerHTML="&nbsp;";
                td.className="pencil";
                row.appendChild (td);

                td = document.createElement ('td');
                td.innerHTML="&nbsp;";
                row.appendChild (td);
                td = document.createElement ('td');

                td.className="hours";
                td.innerHTML="&nbsp;";
                row.appendChild (td);
                tableContainer.appendChild(row);
                rowCount++;
            }
            gadgetBody.style.height=194;
        }
        else {
            gadgetBody.style.height=bodyHeight;
        }
    }

    if (selectedTimer && timerRunning) {
        try {
            DEBUG(" setting active state");
            document.getElementById(selectedTimer.id).style.backgroundImage = "url(Images/selected-row-bg.png)";
        } catch (e) {
            DEBUG(selectedTimer.id+" NOT FOUND");
        }
    }

    updateDaySum();

}


//starts the animated network status rollie
function startNetworkActivityRollie(){
	plusEnabled = false;

	window.clearInterval(networkStatusTimer);
	if (document.getElementById("networkStatus")) {
		networkStatusErrorText.style.display = "none";
		networkStatus.style.display = "block";
		plusMinusButton.style.display="none";
	}
	networkStatusTimer = window.setInterval(animateNetworkActivity, 90);
}

//handles the network rollie animation
function animateNetworkActivity(){
	networkStatusPosition++;
	if (networkStatusPosition > 12) networkStatusPosition = 1;
	if (document.getElementById("networkStatus")) networkStatus.style.background = 'url(Images2/'+networkStatusPosition+'.png) no-repeat 0 0';

}

//Throws up the exclamation point rollie when there's an error
function showNetworkError(msg){
	window.clearInterval(networkStatusTimer);
	if (document.getElementById("networkStatus")) {
		networkStatus.style.display = "block";
		networkStatusErrorText.style.display = "block";
		plusMinusButton.style.display="none";
		newVersionDiv.style.display="none";
		networkStatus.style.background = 'url(Images2/rollie_alert_off.png) no-repeat 0 0';
		networkStatusErrorText.innerHTML=msg
		taskNavigateContainer.style.display="none";
		//playPauseButton.style.display="none";
	}
}

//Hides the network status rollie - happens when the most recent communication with Harvest made it through
function hideNetworkActivityRollie(){
	plusEnabled = true;
	window.clearInterval(networkStatusTimer);
	if (document.getElementById("networkStatus")) {
		networkStatus.style.display = "none";
		networkStatusErrorText.style.display = "none";
		plusMinusButton.style.display="block";
	}
}

function pencilOver(){
	this.src = "Images2/rollie_pencil_down.png";
	row_node = document.getElementById(this.id.substr(12, this.id.length));
	project_task = document.getElementById("projectdiv_" + this.id.substr(12, this.id.length)).innerHTML;
	if (row_node.notes.length > 0)
  	document.getElementById("projectdiv_" + this.id.substr(12, this.id.length)).innerHTML = trimDrawerDisplay("<em> " + row_node.notes +"</em>");
}

function pencilOut(){
	this.src = "Images2/rollie_pencil.png";
	row_node = document.getElementById(this.id.substr(12, this.id.length));
	projecttask = trimDrawerDisplay(row_node.projectName + " (" + row_node.taskName + ")");
    document.getElementById("projectdiv_" + this.id.substr(12, this.id.length)).innerHTML = projecttask;
}


function clickonpencil() {
    aryTR=tbody.getElementsByTagName('tr');
    for (i=0;i<aryTR.length;i++) {
        aryTR[i].style.backgroundImage = "url(Images/drawer-row.png)";
    }
    row_node = document.getElementById(this.id.substr(12, this.id.length));
    toggleTimer(row_node.id)
    if (!selectedTimer) {
        edit_row_data=row_node;
        expandForm();
    }
}

function clickonproject ()
{
	aryTR=tbody.getElementsByTagName('tr');
    for (i=0;i<aryTR.length;i++) {
        aryTR[i].style.backgroundImage = "url(Images/drawer-row.png)";
    }
    row_node = document.getElementById(this.id.substr(11, this.id.length));
    toggleTimer(row_node.id)
    perform_request("daily/timer/" + row_node.id, handleTimerToggleResult,"");
}

function clickonhour ()
{
	aryTR=tbody.getElementsByTagName('tr');
    for (i=0;i<aryTR.length;i++) {
        aryTR[i].style.backgroundImage = "url(Images/drawer-row.png)";
    }
    row_node = document.getElementById(this.id.substr(8, this.id.length));
    toggleTimer(row_node.id)
    perform_request("daily/timer/" + row_node.id, handleTimerToggleResult,"");
}

// starts or stops a timer and optionally stops/updates the previous timer
// called when the server responds with success
function toggleTimer (row_id)
{
    DEBUG("********* Calling ToggleTimer ***********");
    // if there's a previously selected timer, visually unselect it and update the hours
    if (selectedTimer) {
       selectedTimer = '';
    }
    try {
     document.getElementById(row_id).style.backgroundImage = "url(Images/drawer-row.png)";
    } catch (e) {
    }
    // set the new selection as the current timer
    if ((row_data.timer_started_at) || (row_data.day_entry)) {
        row = document.getElementById(row_id);
        if (row) {
            DEBUG('setting selectedTimer '+row.id)
            selectedTimer = row;
            row.style.backgroundImage = "url(Images/selected-row-bg.png)";
            // update main display
            displayUpdate(row, (row_data.timer_started_at) ? row_data.hours : row_data.day_entry.hours);

            //document.getElementById('pencilImage_'+selectedTimer.id).style.opacity = .5;
        }

    } else {
        stopTimer();
    }
    //showPencils();
}


function createRow (object)
{
	DEBUG('creating row: '+object.id);
	var row = document.createElement('tr');

	row.setAttribute ("class", "projectRow");
	row.setAttribute ("id", object.id);
	row.setAttribute ("clientName" , object.client);
	row.setAttribute ("projectId" , object.project_id);
	row.setAttribute ("projectName" , object.project);
	row.setAttribute ("taskId" , object.task_id);
	row.setAttribute ("taskName" , object.task);
	row.setAttribute ("notes" , object.notes);
	row.style.backgroundImage = "url(Images/drawer-row.png)";

	// when you do set up drawer, update the last selected row with the latest time
	// and then add the timer on the new row.
	// if timer is already running, indicate as such
	if (object.timer_started_at || timerID==object.id) {
		//if (selectedTimer) {
			//selectedTimer.style.background = "transparent";
		//}

		DEBUG("setting selectedTimer to: "+ object.id);
		row.style.backgroundImage = "url(Images/selected-row-bg.png)";
		selectedTimer = row;

		// remove this attribute so we only highlight this once upon loading
		object.timer_started_at = '';
		displayUpdate(row, object.hours);
		playPauseButton.setAttribute("row_id",row.id);
  }

	var td = document.createElement ('td');
	td.className="pencil";
	td.setAttribute("id", "projecttaskpencil_" + object.id);
	td.setAttribute("parentID", object.id);
	td.setAttribute("width", "20px");

	var pencilImage = document.createElement("img");
	pencilImage.setAttribute("class", "pencilImage");
	pencilImage.onmouseover = pencilOver;
	pencilImage.onmouseout = pencilOut;
	pencilImage.onclick = clickonpencil;
	pencilImage.setAttribute("id", "pencilImage_"+object.id);
	pencilImage.src = "Images2/rollie_pencil.png";
	td.appendChild(pencilImage);
	row.appendChild(td);

	td = document.createElement('td');
	td.className="projecttask";
	td.setAttribute ("id", "projecttask_" + object.id);
	projecttask = trimDrawerDisplay(object.project + " (" + object.task + ")");

	var divprojecttask=document.createElement('div');
	divprojecttask.onclick=clickonproject
	divprojecttask.setAttribute("id", "projectdiv_"+object.id);
	divprojecttask.style.height="100%";
	divprojecttask.style.width="100%";
	divprojecttask.appendChild(document.createTextNode(htmlUnescape(projecttask)));
	td.appendChild (divprojecttask);
	//td.onclick=function(){dateToday.innerHTML="!"+row.id;}
	//td.attachEvent("onclick",function(){dateToday.innerHTML="!"+row.id;perform_request("daily/timer/" + row.id, handleTimerToggleResult,"");})

	row.appendChild (td);

	td = document.createElement('td');
	td.className="hours";
	td.setAttribute ("align", "right");
	td.setAttribute ("id", "hours_" + object.id);

	var divhour=document.createElement('div');
	divhour.onclick=clickonhour
	divhour.setAttribute("id", "hourdiv_"+object.id);
	divhour.style.height="100%";
	divhour.style.width="100%";
	divhour.appendChild(document.createTextNode(object.hours));

	td.appendChild (divhour);
	row.appendChild (td);
    return row;
}

/*----------------------------------------------------------------------------------
	Functions to update main display
----------------------------------------------------------------------------------*/

// updates the main "player" with current project/task and time
function displayUpdate(row, elapsedHours) {
 	projectDisplay.innerHTML = trimTopDisplay(row.clientName + " - " + row.projectName);
 	taskDisplay.innerHTML = trimTopDisplay(row.taskName);
	if (document.getElementById(row.id)) {
	    row.style.backgroundImage = "url(Images/selected-row-bg.png)";
	    playPauseButton.setAttribute("row_id",row.id);
	}

	// update the time
	// convert decimal to milliseconds
	elapsedTimeInMs = elapsedHours * 3600000;
	startTime = new Date().getTime() - elapsedTimeInMs;
	// start a timer only if one wasn't already running
	window.clearInterval(timerID);
	timerID = window.setInterval(runTimer, 1000);
	timerRunning = true;
    playPauseButton.style.backgroundImage = 'url(Images/button-pause.png)';

}

function stopTimer() {
    window.clearInterval(timerID);
    timerRunning = false;
    selectedTimer = '';
    playPauseButton.style.backgroundImage = 'url(Images/button-play.png)';
}

// takes in elapsed time in thousandth of a second
function runTimer() {
	var Now = new Date().getTime();
	elapsedTime = Now - startTime;

	var afterH= elapsedTime % 3600000;
	timeH = (elapsedTime - afterH) / 3600000;
	var afterM= afterH % 60000;
	timeM = (afterH - afterM) / 60000;
	timeS = Math.floor(afterM / 1000);
	updateTimerDisplay(elapsedTime);
}

function updateTimerDisplay (elapsedTime)
{
	var h = parseInt(timeH, 10);
	var m = parseInt(timeM, 10);
	var s = parseInt(timeS, 10);
	if (timerRunning == true) {
		if (s < 10) s = '0' + s;
		if (m < 10) m = '0' + m;
		if (h < 10) h = '0' + h;
		// document.getElementById('timeDisplay').innerHTML = "<span class='timerRunning'>" + h + ":" + m + "</span>";
		timeDisplay.innerHTML = "<span class='timerRunning'>" + (elapsedTime / 3600000).toFixed(2) + "</span>";
	}

	// update the selected row's hours and update the overall day's hours
	// new_hours = convert_hhmm_to_decimal(h+":"+m);
	try {
	    document.getElementById("hourdiv_" + selectedTimer.id).innerHTML = (elapsedTime / 3600000).toFixed(2);
	} catch (e) {

	}
	updateDaySum();
}

/*----------------------------------------------------------------------------------
	Math functions
----------------------------------------------------------------------------------*/

// adds sums from the day's tasks and refreshes the display at top
function updateDaySum() {
	totalToday.innerHTML = 'executing..';
	var daySum = 0;
	$A(data.day_entries).each(function(e){
	   if (timerRunning && e.id==selectedTimer.id) {
	        var timeDisplayHTML= timeDisplay.innerHTML.replace(/<[^>]*>/gi, "");
	        e.hours=parseFloat(timeDisplayHTML);
	    }
	    daySum += e.hours;
    });
	totalToday.innerHTML = daySum.toFixed(2);
}

function convert_hhmm_to_decimal (input_value) {
  if ((input_value != null) && (input_value.indexOf) && (input_value.indexOf(':') != -1)) {
    time = input_value.split(':');
    if (time[0] == "") {
      hours = 0;
    }  else {
      hours = parseFloat(time[0]);
    }
    minutes = parseFloat(time[1] / 60);
    input_value = (minutes + 0 + hours).toFixed(2);
  }
  return input_value;
}


/*----------------------------------------------------------------------------------
	Time entry drawer functions
----------------------------------------------------------------------------------*/

/** form expansion and collapse **/
function expandForm(forceRefresh) {
    System.Gadget.Flyout.show = true;
 	plusMinusButton.style.backgroundImage = 'url(Images/button-minus.png)';
	formExpanded = true;
}

function loadProjectsList() {
	// load options into the project dropdown
	var currentClient = ''
	var optGroup=null;
	projectInput.innerHTML = '';

  $A(data.projects).sortBy(function(p){return p.client + p.name}).each(function(p){
					// if this is a new client, create the option group for it
					if (currentClient != p.client)  {
						// add the last option group to the input selector if one has been created
						if (currentClient != '')
							projectInput.appendChild(optGroup);
						optGroup = document.createElement("optgroup");
						optGroup.setAttribute("label", p.client)
						currentClient = p.client;
					}

					// keep adding this to the option group
					var option = document.createElement("option");
					option.value = p.id;
					option.innerHTML = p.name;
					optGroup.appendChild(option);

        });

  // tack on the final optgroup
  if (optGroup) {
    projectInput.appendChild(optGroup);
  }

	// display the default
	projectInput.selectedIndex = 0;

//	projectInput.value = data.projects[0].id;

	// load default task list
	loadTasksList(data.projects[0].id);
}

function loadTasksList(project_id) {
	if (!project_id)
	  project_id = 1;

	removeAllChildren(taskInput);

	// we always start with the billable group
	var billable = false;
	var currentGroup = '';
	$A(data.projects).each(function(p){
					// if we have a match, print out the tasks
					if (p.id == project_id) {
						$A(p.tasks).sortBy(function(t){return !t.billable + t.name}).each(function(t){
								var option = document.createElement("option");
								option.value = t.id;
								// option.innerHTML = htmlEscape(t.name);
								option.innerHTML = t.name;
								// set the default
								// if the current group matches this task's billable status, add it in
								currentTask = t.billable ? "Billable" : "Non-billable";
								if (currentGroup != currentTask) {
									// wrap up the first option group
									if (currentGroup != '') {
 										taskInput.appendChild(optGroup);
									}
									// start the next one
									optGroup = document.createElement("optgroup");
									optGroup.setAttribute("label", currentTask);
									currentGroup = currentTask;
								}
								optGroup.appendChild(option);
              });
						// add last group to option group
						taskInput.appendChild(optGroup);
					}
        });
}

function collapseForm() {
    if (System.Gadget.Flyout.show) {
        System.Gadget.Flyout.show = false;
        try {
	        plusMinusButton.style.backgroundImage = 'url(Images/button-plus.png)';
	        refreshGadget();
	    }
	    catch (e) {
	        System.Gadget.document.parentWindow.document.getElementById('plusMinusButton').style.backgroundImage = 'url(Images/button-plus.png)';
	        System.Gadget.document.parentWindow.refreshGadget();
	    }

	    formExpanded = false;
	}
}




/*** UTIL FUNCTIONS ***/

function removeAllChildren (parent)
{
	while (parent.hasChildNodes()) {
		parent.removeChild(parent.firstChild);
	}
}

function clearAllClickDelays() {
	for (i = 0; i <= clickDelay.length; i++) {
	  clearTimeout(clickDelay.pop());
	}
}

function htmlUnescape(inText) {
	return inText.replace(/&amp;/g, "&");
}

function htmlEscape(inText) {
	return inText.replace(/&/g, "&amp;");
}

function checkEnterSubmit(event) {
  if (event.keyCode == 13) {
		handleSaveTimeClick();
  }
}

// extend the Date object to return day of the year
function AddDoYMethods()
{function FDoY()
  {
    with (this)
    {
      var Y = getFullYear(), M = getMonth(), D = getDate();
    }
    return Math.round(Math.abs(Date.UTC(Y, M, D)-Date.UTC(Y, 0, 0))/86400000);
  }
  Date.prototype.getDoY = FDoY;
}

function trimTopDisplay(inputText) {
	if (inputText.length > MAX_TOP_DISPLAY_LENGTH)
	  return inputText.substr(0, MAX_TOP_DISPLAY_LENGTH) + "...";
	else
  	return inputText;
}

function trimDrawerDisplay(inputText) {
	if (inputText.length > MAX_DRAWER_DISPLAY_LENGTH) {
	  if ((inputText.indexOf("<em>") != -1))
	 		return inputText.substr(0, MAX_DRAWER_DISPLAY_LENGTH + 10) + "...";
	  else
	  	return inputText.substr(0, MAX_DRAWER_DISPLAY_LENGTH) + "...";
	} else
  	return inputText;
}

/*----------------------------------------------------------------------------------
  XMLhttp functions
----------------------------------------------------------------------------------*/

function perform_request(action, result_handler, post) {
    var harvestURL = System.Gadget.Settings.read("envHarvestURL");
    var harvestEmail = System.Gadget.Settings.read("envHarvestEmail");
    var harvestPassword = System.Gadget.Settings.read("envHarvestPassword");

    var p = String(harvestURL); // Typecasting to string - Modification made by Dan Storm - storm@err0r.dk 2010-01-15
    if (p.slice(0, 7) == "http://") p = p.slice(7, p.length);
    if (p.slice(0, 8) == "https://") p = p.slice(8, p.length);

    protocol = "https://";

    url=protocol+harvestURL+".harvestapp.com/"+action;
    request = new XMLHttpRequest();

    request.onreadystatechange = function(e) {
	    if (request.readyState == 4) {
	        protocol = request.getResponseHeader('X-Served-From');
			if (protocol.slice(0, 7) == "http://") protocol = "http://";
			if (protocol.slice(0, 8) == "https://") protocol = "https://";
			System.Gadget.Settings.write("envHarvestProtocol", protocol)
			if(request.status >= 200 && request.status < 300) {
	            DEBUG(request.responseText);
		        // handle misc post call functions
		        //Successfully got data from Harvest server, so hide the network status rollie.
		        hideNetworkActivityRollie();
		        result_handler();

            } else if (request.status == 401) {
		        DEBUG("401");
		        showNetworkError("Invalid URL or login.");
	        } else if (request.status == 400) {
		        DEBUG("400");
		        showNetworkError("Gadget requires <a href='javascript:goToHarvestPlans();'>account upgrade</a>.");
	        } else if (request.status == 503) {
		        DEBUG("503");
		        showNetworkError("API throttle limit exceeded.");
	        } else {
                // notify about errors
		        //showNetworkError(request.status+ "-undefined error");
	            //DEBUG("undefined error!");
	            hideNetworkActivityRollie();
	            result_handler();
            }
	    }
    }

    startNetworkActivityRollie();
	request.open("POST", url, true);

    request.setRequestHeader("Authorization", "Basic " + encode64(harvestEmail + ":" + harvestPassword));
    request.setRequestHeader("Cache-Control", "no-cache");
    request.setRequestHeader("Accept", "application/json");
    request.setRequestHeader("Content-Type", "application/json");
    request.setRequestHeader("User-Agent", "HarvestGadget");
    request.send(post.toJSONString());
}

function handleDailyResult() {
    // use the latest data buffer and set up the toggler
    if (request.responseText.indexOf('xhtml1') == -1)
        try {
            data = eval('(' + request.responseText + ')');
        }
        catch (e) {
            data = false
        }
    else
        data = false

    DEBUG("data: "+ data);
    // if our response didn't work (probably redirected) try other protocol
    if (data == false) {
        protocol = 'https://';
        if (secondAttempt == false) {
            perform_request("daily", handleDailyResult, "");
            secondAttempt = true;
        } else {
            showNetworkError("Invalid URL or login.");
        }
    } else {

        CURRENT_DAILY_ENTRY=data.day_entries.length-MAX_DAILY_ENTRIES;
        if (CURRENT_DAILY_ENTRY<=0) {
            CURRENT_DAILY_ENTRY=0;
        }
        CURRENT_DAILY_STOP=data.day_entries.length;

        setupTaskTable();
    }
}

function handleDailyAddResult() {
	new_entry = request.responseText.parseJSON();

	if (System.Gadget.document.parentWindow.data.day_entries == null) {
		System.Gadget.document.parentWindow.data.day_entries = new Array();
	}

	// need to do this silly casing because the data is different depending on previously running timer
	if (new_entry.day_entry) {
		System.Gadget.document.parentWindow.data.day_entries.push(new_entry.day_entry);
	} else {
		System.Gadget.document.parentWindow.data.day_entries.push(new_entry);
	}

	// DW: can't call this as this will use old data
	//setupTaskTable();
}

function handleTimerToggleResult() {
	row_data = request.responseText.parseJSON();
	if (row_data.day_entry) {
		// selectedTimer = '';
		toggleTimer (row_data.day_entry.id);
	} else
	 	toggleTimer (row_data.id);
}

function handleDailyEditResult() {
	row_data = request.responseText.parseJSON();

	// update all display values
	editedRowProjectTask = System.Gadget.document.parentWindow.document.getElementById("projecttask_" + row_data.id);
	projecttask = trimDrawerDisplay(row_data.project + " (" + row_data.task + ")");
	editedRowProjectTask.innerHTML = projecttask;

	editedRowHours = System.Gadget.document.parentWindow.document.getElementById("hourdiv_" + row_data.id);
	editedRowHours.innerHTML = row_data.hours;

	// set all the row attributes to new values

	row = System.Gadget.document.parentWindow.document.getElementById(row_data.id);
	row.setAttribute ("clientName" , row_data.client);
	row.setAttribute ("projectId" , row_data.project_id);
	row.setAttribute ("projectName" , row_data.project);
	row.setAttribute ("taskId" , row_data.task_id);
	row.setAttribute ("taskName" , row_data.task);
	row.setAttribute ("notes" , row_data.notes);

	setTimeout('updateDaySum();', 500);
}

function handleBackInputValid() {
	document.getElementById('debugDiv').innerHTML = "";
	handleDailyResult();
}

/*
 ************************************************************************
 * Debug code 																												  *
 ************************************************************************
 */
var debugMode = false;

// write to the debug div
function DEBUG(str) {
	if (debugMode) {
		var debugDiv = document.getElementById("debugDiv");
		debugDiv.appendChild(document.createTextNode(str));
		debugDiv.appendChild(document.createElement("br"));
		debugDiv.scrollTop = debugDiv.scrollHeight;
	}
}

// Toggle the debugMode flag, but only show the debugDiv if we're in Safari
function toggleDebug() {
	debugMode = !debugMode;
	if (debugMode == true) {
		document.getElementById("debugDiv").style.display = "block";
	} else {
		document.getElementById("debugDiv").style.display = "none";
	}
}


function debug(msg) {
	if (!debug.box) {
		debug.box = document.createElement("div");
		debug.box.setAttribute("style", "background-color: white; " +
										"color: red; " +
										"font-family: monospace; " +
										"font-size: 10; " +
										"border: solid black 3px; " +
										"position: absolute;top:0px;" +
										"z-index: 100;" +
										"padding: 10px;");

		document.body.appendChild(debug.box);
	}

	var p = document.createElement("p");
	p.appendChild(document.createTextNode(msg));
	debug.box.appendChild(p);
}

function getVersionNumber(){
	var req=new XMLHttpRequest();
    var url = "http://www.getharvest.com/downloads/sidebar-ver.txt";
    req.onreadystatechange=function() {
	    if (req.readyState==4 && /^(200|304)$/.test(req.status.toString())){
            latestVersion = req.responseText;
		    if (version < Number(latestVersion) && version!=Number(latestVersion)) {
                document.getElementById("newVersionDiv").style.display="block";
		    }
	    }
    }
    req.open("GET", url, true);
    req.setRequestHeader("Cache-Control", "no-cache");
    req.send(null)

}
